- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# cnos_command – Run arbitrary commands on Lenovo CNOS devices

New in version 2.6.

- Synopsis
- Parameters
- Examples
- Return Values
- Status

## Synopsis

- Sends arbitrary commands to an CNOS node and returns the results read from the device. The `cnos_command` module includes an argument that will cause the module to wait for a specific condition before returning or timing out if the condition is not met.

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
commands - / required added in 2.6 |  | List of commands to send to the remote device. The resulting output from the command is returned. If the wait_for argument is provided, the module is not returned until the condition is satisfied or the number of retires is expired.
interval - added in 2.6 | Default: 1 | Configures the interval in seconds to wait between retries of the command. If the command does not pass the specified conditions, the interval indicates how long to wait before trying the command again.
match - added in 2.6 | Choices: any all ← | The match argument is used in conjunction with the wait_for argument to specify the match policy. Valid values are `all` or `any`. If the value is set to `all` then all conditionals in the wait_for must be satisfied. If the value is set to `any` then only one of the values must be satisfied.
retries - added in 2.6 | Default: 10 | Specifies the number of retries a command should by tried before it is considered failed. The command is run on the target device every retry and evaluated against the wait_for conditions.
wait_for - added in 2.6 |  | List of conditions to evaluate against the output of the command. The task will wait for each condition to be true before moving forward. If the conditional is not true within the configured number of retries, the task fails. See examples.

## Examples

    ---
    - name: test contains operator
      cnos_command:
        commands:
          - show version
          - show system memory
        wait_for:
          - "result[0] contains 'Lenovo'"
          - "result[1] contains 'MemFree'"
      register: result

    - assert:
        that:
          - "result.changed == false"
          - "result.stdout is defined"

    - name: get output for single command
      cnos_command:
        commands: ['show version']
      register: result

    - assert:
        that:
          - "result.changed == false"
          - "result.stdout is defined"

    - name: get output for multiple commands
      cnos_command:
        commands:
          - show version
          - show interface information
      register: result

    - assert:
        that:
          - "result.changed == false"
          - "result.stdout is defined"
          - "result.stdout | length == 2"

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
failed_conditions list | failed | the conditionals that failed Sample: ['...', '...']
stdout list | always | the set of responses from the commands Sample: ['...', '...']
stdout_lines list | always | The value of stdout split into a list Sample: [['...', '...'], ['...'], ['...']]

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]
- This module is maintained by the Ansible Community. [community]

### Authors

- Anil Kumar Muraleedharan (@amuraleedhar)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.